package javakurssi1;

public class Limuautomaatti {
  private double saldo = 0.0; // Kokooja

  /** Palauttaa kokiksen hinnan euroina.
    * 
    * @return kokiksen hinnan euroina.
    */
  public double getKokiksenHinta() {
    return 1.60;
  }
  
  /** Laittaa annetun rahamrn automaattiin.
    * 
    * @param rahaMaara laitettavan rahan mr euroina.
    */
  public void laitaRahaa(double rahaMaara) {
    this.saldo += rahaMaara;
  }
  
  /** Palauttaa automaatissa olevan rahamrn euroina.
    * 
    * @return automaatissa olevan rahamrn euroina.
    */
  public double getSaldo() {
    return saldo;
  }
  
  /** Yrtt ostaa kokiksen. Jos automaatissa on tarpeeksi
    * rahaa kokiksen ostamista varten, palauttaa uuden kokis-
    * pullon, muuten palauttaa <code>null</code>.
    * 
    * @return Uusi kokispullo, jos saldo on riittv,
    *          muutoin <code>null</code>.
    */ 
  public Kokispullo ostaKokis() {
    if (this.saldo >= getKokiksenHinta()) {
      this.saldo -= getKokiksenHinta();
      return new Kokispullo();
    } else {
      return null;
    }
  }
  
  public String toString() {
    return String.format("Limuautomaatti, saldo %.2f euroa.", getSaldo());
  }
}