package javakurssi2;

import java.util.ArrayList;

public class Limuautomaatti {
  private double saldo; // Kokooja
  private ArrayList<Kokispullo> sailio;
  
  /** Tyhjn limuautomaatin konstruktori.
    * Luodun limuautomaatin sili on
    * tyhj ja saldo nolla.
    */
  public Limuautomaatti() {
    this.saldo = 0.0;
    this.sailio = new ArrayList<Kokispullo>();
  }

  /** Palauttaa kokiksen hinnan euroina.
    * 
    * @return kokiksen hinnan euroina.
    */
  public double getKokiksenHinta() {
    return 1.60;
  }
  
  /** Laittaa annetun rahamrn automaattiin.
    * 
    * @param rahaMaara laitettavan rahan mr euroina.
    */
  public void laitaRahaa(double rahaMaara) {
    this.saldo += rahaMaara;
  }
  
  /** Palauttaa automaatissa olevan rahamrn euroina.
    * 
    * @return automaatissa olevan rahamrn euroina.
    */
  public double getSaldo() {
    return saldo;
  }
  
  /** Yrtt ostaa kokiksen. Jos automaatissa on tarpeeksi
    * rahaa kokiksen ostamista varten, ja siliss on pulloja,
    * palauttaa silin ensimmisen kokispullon,
    * muuten palauttaa <code>null</code>.
    * 
    * @return Kokispullo, jos saldo on riittv,
    *          muutoin <code>null</code>.
    */ 
  public Kokispullo ostaKokis() {
    if (this.sailio.size() > 0 && this.saldo >= getKokiksenHinta()) {
      Kokispullo pullo = sailio.get(0);
      sailio.remove(0);
      
      this.saldo -= getKokiksenHinta();
      return pullo;
    } else {
      return null;
    }
  }
  
  /** Lis kokiksen automaatin silin. Lisjn tulee itse
    * huolehtia kokiksesta luopumisesta lismisen jlkeen.
    * 
    * @param pullo listtv kokispullo.
    */
  public void lisaaKokis(Kokispullo pullo) {
    this.sailio.add(pullo);
  }
  
  public String toString() {
    return String.format("Limuautomaatti, saldo %.2f euroa.", getSaldo());
  }
}