package javakurssi3;

import java.util.List;
import java.util.ArrayList;

public class Limuautomaatti {
  private double saldo = 0.0; // Kokooja
  private List<Pullo> sailio;
  
  /** Tyhjn limuautomaatin konstruktori.
    * Luodun limuautomaatin sili on
    * tyhj ja saldo nolla.
    */
  public Limuautomaatti() {
    this.saldo = 0.0;
    this.sailio = new ArrayList<Pullo>();
  }

  /** Palauttaa juoman hinnan euroina.
    * 
    * @return juoman hinnan euroina.
    */
  public double getJuomanHinta(String juomanNimi) {
    return 1.60;
  }
  
  /** Laittaa annetun rahamrn automaattiin.
    * 
    * @param rahaMaara laitettavan rahan mr euroina.
    */
  public void laitaRahaa(double rahaMaara) {
    this.saldo += rahaMaara;
  }
  
  /** Palauttaa automaatissa olevan rahamrn euroina.
    * 
    * @return automaatissa olevan rahamrn euroina.
    */
  public double getSaldo() {
    return saldo;
  }
  
  /** Yrtt ostaa juoman. Jos automaatissa on tarpeeksi
    * rahaa juoman ostamista varten, ja juoma lytyy
    * silist, palauttaa uuden juomapullon, muuten
    * palauttaa <code>null</code>.
    * 
    * @return Juomapullo, jos saldo on riittv,
    *          muutoin <code>null</code>.
    */ 
  public Pullo ostaJuoma(String juomanNimi) {
    if (this.saldo >= getJuomanHinta(juomanNimi)) {
      int pullonIndeksi = -1;
      for (int i=0; i<this.sailio.size(); i++) {
        if (this.sailio.get(i).getNimi().equals(juomanNimi)) {
          pullonIndeksi = i;
          break;
        }
      }
      if (pullonIndeksi != -1) {
        Pullo pullo = this.sailio.get(pullonIndeksi);
        this.sailio.remove(pullonIndeksi);
        return pullo;
      }
    }
    
    return null;
  }
  
  /** Lis pullon automaatin silin. Lisjn tulee itse
    * huolehtia pullosta luopumisesta lismisen jlkeen.
    * 
    * @param pullo listtv pullo.
    */
  public void lisaaPullo(Pullo pullo) {
    this.sailio.add(pullo);
  }
  
  /** Tarkistaa, onko annettua juomaa limuautomaatissa.
    * 
    * @param juomanNimi tarkistettavan juoman nimi.
    */
  public boolean onkoJuomaa(String juomanNimi) {
    for (Pullo pullo : this.sailio) {
      if (pullo.getNimi().equals(juomanNimi)) {
        return true;
      }
    }
    return false;
  }
  
  public String toString() {
    return String.format("Limuautomaatti, saldo %.2f euroa.", getSaldo());
  }
}