package puhelinluettelo;

import java.io.*;
import java.util.*;
import java.util.regex.*;

/** Kyttliittym puhelinluettelon kyttmist varten.
  * 
  */
public class Kayttoliittyma {
  /** Nyt kyttjlle kehote ja
    * lue syte nppimistlt.
    */
  private BufferedReader reader;
  private Puhelinluettelo luettelo;
  
  public Kayttoliittyma() {
    InputStreamReader isr = new InputStreamReader(System.in);
    reader = new BufferedReader(isr);
    luettelo = new Puhelinluettelo();
  }
  
  public boolean lueJaToteuta() throws java.io.IOException {
    String syote = reader.readLine();
    Scanner s = new Scanner(syote);
    
    // Listaus
    String luettu = s.findInLine("^listaa$");
    if (luettu != null) {
      for (String string: luettelo.listaa()) {
        System.out.println(string);
      }
      return true;
    }
    
    // Etsiminen
    luettu = s.findInLine("^etsi +([a-zA-Z ]+)$");
    if (luettu != null) {
      String string = luettelo.etsi(s.match().group(1));
      if (string != null) {
        System.out.println(string);
      }
      return true;
    }
    
    // Lisminen
    luettu = s.findInLine("^lis(aa|) +([a-zA-Z ]+), *([0-9 ]+)$");
    if (luettu != null) {
      String g1 = s.match().group(2);
      g1 = g1 != null ? g1 : "";
      String g2 = s.match().group(3);
      g2 = g2 != null ? g2 : "";
      luettelo.lisaa(g1, g2);
      return true;
    }
    
    // Poistaminen
    luettu = s.findInLine("^poista +([a-zA-Z ]+)$");
    if (luettu != null) {
      luettelo.poista(s.match().group(1));
      return true;
    }
    
    luettu = s.findInLine("^poistu$");
    if (luettu != null) {
      return false;
    }
    
    return true;
  }
  
  public static void main(String[] args) {
    Kayttoliittyma kayttoliittyma = new Kayttoliittyma();
    try {
      while (kayttoliittyma.lueJaToteuta()) {
        /* l tee mitn */
      }
    } catch (IOException ie) {
      System.out.println(ie);
    }
  }
}