/** Puhelinluettelossa oleva merkint, joka
  * kuvaa yhden henkiln nimen ja puhelinnumeron.
  */

package puhelinluettelo;

class Merkinta {
  private String nimi;
  private String numero;
  
  /** Luo uuden puhelinluettelomerkinnn.
    * 
    * @param nimi Merkinnn esittmn henkiln nimi.
    * @param numero Merkinnn esittmn henkiln puhelinnumero.
    */
  public Merkinta(String nimi, String numero) {
    if (nimi == null) {
      nimi = "-";
    }
    if (numero == null) {
      numero = "-";
    }
    this.nimi = nimi;
    this.numero = numero;
  }
  
  /** Palauttaa merkinnn esittmn henkiln nimen.
    * 
    * @return Merkinnn nimi.
    */
  public String getNimi() {
    return nimi;
  }
  
  /** Palauttaa merkinnn esittmn henkiln puhelinnumeron.
    *
    * @return Merkinnn esittmn henkiln puhelinnumero.
    */
  public String getNumero() {
    return numero;
  }
}