package puhelinluettelo;

import java.util.ArrayList;

/** Puhelinluettelo, joka sislt merkintj.
  */
public class Puhelinluettelo {
  private ArrayList<Merkinta> merkinnat;
  
  /** Luo uuden puhelinluettelon.
    */
  public Puhelinluettelo() {
    this.merkinnat = new ArrayList<Merkinta>();
  }
  
  /** Lis luetteloon uuden merkinnn annetulla
    * nimell ja puhelinnumerolla.
    */
  public void lisaa(String nimi, String numero) {
    Merkinta merkinta = new Merkinta(nimi, numero);
    
    merkinnat.add(merkinta);
  }
  
  /** Listaa kaikki luettelossa olevat merkinnt.
    */
  public String[] listaa() {
    ArrayList<String> merkkijonot = new ArrayList<String>();
    for (Merkinta merkinta : merkinnat) {
      merkkijonot.add(merkinta.getNimi() + ", " + merkinta.getNumero());
    }
    
    return merkkijonot.toArray(new String[] {});
  }
  
  /** Etsii merkinnn, jonka nimi sislt annetun
    * hakulauseen.
    */
  public String etsi(String hakulause) {
    for (Merkinta merkinta : merkinnat) {
      if (merkinta.getNimi().contains(hakulause)) {
        return merkinta.getNimi() + ", " + merkinta.getNumero();
      }
    }
    
    return null;
  }
  
  /** Poistaa ensimmisen merkinnn, jonka nimi
    * tsm annetun nimen kanssa.
    */
  public void poista(String nimi) {
    int poistettavanIndeksi = -1;
    for (int i=0; i < merkinnat.size(); i++) {
      if (merkinnat.get(i).getNimi().equals(nimi)) {
        poistettavanIndeksi = i;
      }
    }
    
    // Poistetaan vain, jos merkint lytyy
    if (poistettavanIndeksi != -1) {
      merkinnat.remove(poistettavanIndeksi);
    } else {
      throw new IllegalArgumentException("Merkint ei ole olemassa!");
    }
  }
}